#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/rope>

#define ff(i,a,b) for(int (i) = (a); (i) <= (b); ++(i))
#define fb(i,a,b) for(int (i) = (a); (i) >= (b); --(i))
#define mod 998244353
#define xx first
#define yy second
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define ll long long
#define pii pair<int,int>


using namespace std;
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>,rb_tree_tag, tree_order_statistics_node_update> ordered_set;/// find_by_order(x)(x+1th) , order_of_key() (strictly less)
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int n,m;

ll niz[100005][2];

void solve(){
    cin >> n >> m;
    ff(i,1,n){
        cin >> niz[i][0];
    }
    ff(i,1,m){
        cin >> niz[i][1];
    }
    sort(niz[0] + 1, niz[0] + 1 + n);
    ll sta = niz[2][0] - niz[1][0];
    ff(i,2,n){
        sta = __gcd(sta, niz[i][0] - niz[i - 1][0]);
    }
    ll koji = niz[1][0]%sta;
    ff(i,1,m){
        ll pom = niz[i][1]%sta;
        if(pom == koji){
            cout << 0 << "\n";
            return;
        }
    }
    cout << 1 << "\n";
    return;
}

int main()
{

    ios_base::sync_with_stdio(false); cin.tie(0);
    int t;
    cin >> t;
    while(t--)solve();
    return 0;
}